import Webworker from './web-worker';
import CryptoBin from './crypto-bin';


var getCrypto = common => {
  var cryptoWorker = CryptoBin();
  var useWorker = common.use.webworker;
  if (useWorker) {
    try {
      var webWorker = Webworker.of();
      var factorize = args => webWorker.run('factorize', args);

      var modPow = args => webWorker.run('mod-pow', args);

      cryptoWorker.factorize = factorize;
      cryptoWorker.modPow = modPow;
    } catch (err) {
      useWorker = false;
    }
  }
  common.use.webworker = useWorker;

  return cryptoWorker;
};

export default getCrypto;
//# sourceMappingURL=index.js.map