import { Stream } from 'most';
import { Either } from 'funfix';

function cata(cases, either) {
  var isRight = either.isRight();
  var { Right, Left } = cases;
  if (isRight) {
    var r = either.get();
    var result = Right(r);
    return result;
  } else {
    var swap = either.swap();
    var l = swap.get();
    var _result = Left(l);
    return _result;
  }
}

export function cataC(cases) {
  return function switchCata(either) {
    var result = cata(cases, either);
    return result;
  };
}

export function cataStream(cases) {
  return function switchCataStream(stream) {
    var mapped = stream.map(val => cata(cases, val));
    return mapped;
  };
}

export default cata;
//# sourceMappingURL=cata.js.map