'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _webWorker = require('./web-worker');

var _webWorker2 = _interopRequireDefault(_webWorker);

var _cryptoBin = require('./crypto-bin');

var _cryptoBin2 = _interopRequireDefault(_cryptoBin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getCrypto = common => {
  var cryptoWorker = (0, _cryptoBin2.default)();
  var useWorker = common.use.webworker;
  if (useWorker) {
    try {
      var webWorker = _webWorker2.default.of();
      var factorize = args => webWorker.run('factorize', args);

      var modPow = args => webWorker.run('mod-pow', args);

      cryptoWorker.factorize = factorize;
      cryptoWorker.modPow = modPow;
    } catch (err) {
      useWorker = false;
    }
  }
  common.use.webworker = useWorker;

  return cryptoWorker;
};

exports.default = getCrypto;
//# sourceMappingURL=index.js.map