'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _redux = require('redux');

var _reduxAct = require('redux-act');

var _ramda = require('ramda');

require('../index.h');

var _action = require('../action');

require('../epic/task');

var _networkerState = require('./networker-state');

var _networkerState2 = _interopRequireDefault(_networkerState);

var _request = require('./request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var active = (0, _reduxAct.createReducer)({
  //$FlowIssue
  [_action.MAIN.ACTIVATED]: () => true
}, false);

var uid = (0, _reduxAct.createReducer)({
  //$FlowIssue
  [_action.MAIN.SWITCH_ON]: (state, payload) => payload
}, ' ');

var messageHistory = (0, _reduxAct.createReducer)({
  //$FlowIssue
  [_action.API.DONE_REQUEST]: (state, data) => {
    // console.log(data)
    var { result, thread, messages } = data,
        rest = _objectWithoutProperties(data, ['result', 'thread', 'messages']);
    // console.log(result)
    // console.log(rest)
    return (0, _ramda.append)({
      messages,
      direction: 'in' }, state);
  },
  //$FlowIssue
  [_action.NET.SEND]: (state, payload) => (0, _ramda.append)({
    id: payload.message.msg_id,
    seqNo: payload.message.seq_no,
    direction: 'out' }, state)
}, []);

var homeDc = (0, _reduxAct.createReducer)({}, 2);

var mainReducer = (0, _redux.combineReducers)({
  _: () => true,
  active,
  homeDc,
  uid,
  messageHistory,
  networker: _networkerState2.default,
  request: _request2.default
});

exports.default = mainReducer;
//# sourceMappingURL=index.js.map