'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _redux = require('redux');

var _reduxAct = require('redux-act');

var _action = require('../action');

require('../epic/task');

var _immutableList = require('../../util/immutable-list');

var _immutableList2 = _interopRequireDefault(_immutableList);

require('../../util/either');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var api = (0, _reduxAct.createReducer)({
  //$FlowIssue
  [_action.API.NEW_REQUEST]: (state, payload, meta) => state.set(meta.id, Object.assign({}, payload, { timestamp: new Date(payload.timestamp) })),
  //$FlowIssue
  [_action.API.DONE_REQUEST]: (state, payload, meta) => {
    var matcher = {
      Right(data) {
        // console.log('data', data)
        var { value } = data;
        var linked = value.ids.linked;
        if (linked && state.has(linked)) state.get(linked).netReq.deferFinal.resolve(value.data);
      },
      Left(data) {
        // console.log('data l', data)
        var { value } = data;
        var linked = value.ids.linked;
        if (linked && state.has(linked)) state.get(linked).netReq.deferFinal.reject(value.data);
      }
    };
    if (Array.isArray(payload.messages)) {
      for (var _iterator = payload.messages, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var _message = _ref;

        _message.matchWith(matcher);
      }
    }return state; //.delete(meta.id)
  }
}, _immutableList2.default.empty());

var reducer = (0, _redux.combineReducers)({
  api
});

exports.default = reducer;
//# sourceMappingURL=request.js.map