'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _most = require('most');

var _mtprotoLogger = require('mtproto-logger');

var _mtprotoLogger2 = _interopRequireDefault(_mtprotoLogger);

require('../property');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var log = _mtprotoLogger2.default`observer`;

//$FlowIssue
function Observer({ next, error, complete }) {
  //$FlowIssue
  return stream => _bluebird2.default
  //$FlowIssue
  .try(() => {
    var streamNext = stream.map(val => _bluebird2.default.try(() => next(val)).tap(data => {
      if (isStream(data) === false) stream.complete(data);
    })).awaitPromises();
    return streamNext.chain(val => isStream(val) ? val : (0, _most.of)(val)).recoverWith(error)
    // .tap(log`after recover`)
    .observe(x => x);
  }).then(complete);
}

function isStream(val) {
  return val instanceof _most.Stream;
}

exports.default = Observer;
//# sourceMappingURL=observer.js.map